#!/usr/bin/env python
# coding: utf-8

#导入数据处理的基础包
import numpy as np
import re,os,sys,time,copy
import emoji
from opencc import OpenCC

def cont2_repl(matchobj):
	#if matchobj.group(0) == '-': return ' '
	#else: return '-'
	a=matchobj.group(0)
	#print(a)
	return a[0]

#半角处理
#去掉全部英文字符!!!
#去除字母数字表情和其它字符
def clear_character_half(sentence,erase_space=True):
	#pattern1='[a-zA-Z0-9]'
	pattern1='[a-zA-Z0-9]'
	#pattern2 = re.compile(u'[^\s1234567890:：' + '\u4e00-\u9fa5]+')
	#pattern2 = re.compile(u'[^\s1234567890:：]+')
	#pattern3='[’!"#$%&\'()*+,-./:;<=>?@[\\]^_`{|}~]+' #this wrong
	pattern3='[’#$%&\*+<-=>?@\\^_`{|}~ಠ←╮(╯▽╰)╭]+'
	pattern4='[/]+'

	line1=re.sub(pattern1,'',sentence)   #去除英文字母和数字
	#line2=re.sub(pattern2,'',line1)   #去除表情和其他字符
	line2=line1
	line3=re.sub(pattern3,'',line2)   #去除去掉残留的冒号及其它符号
	line4=re.sub(pattern4,'',line3)


	#pattern10='[,.:;"(.)"[,].]{2,}' #this wrong
	pattern10='[,"\'.:[\];()!]{2,}' #erase continuous char,e.g.:,,,=>,; NOTE:,.;[]^%=>, NOT ,.;[]^%=>,.;[]^%;

	#result = re.match(pattern10, line4)  #match() always return None; ???
	#result = re.search(pattern10, line4)  #search() is ok	
	#print(result.group())
	#line20=re.sub(pattern10,'',line4)
	line20=re.sub(pattern10,cont2_repl,line4)

	if erase_space:
		new_sentence=''.join(line20.split()) #去除空白
	else:
		new_sentence=line20
	return new_sentence

#全角处理
#erase cont chars; e.g.:。,，=>。;  input-string include half & full; 
def clear_character_full(sentence,erase_space=True,replace_symbo_space_as_comma=False):
	#pattern1='[a-zA-Z0-9]'
	#pattern1='[a-zA-Z0-9]'
	#pattern2 = re.compile(u'[^\s1234567890:：' + '\u4e00-\u9fa5]+')
	#pattern2 = re.compile(u'[^\s1234567890:：]+')
	#pattern3='[’!"#$%&\'()*+,-./:;<=>?@[\\]^_`{|}~]+' #this wrong
	#pattern3='[’"#$%&\'*+<-=>?@\\^_`{|}~]+'
	#pattern4='[/]+'

	#line1=re.sub(pattern1,'',sentence)   #去除英文字母和数字
	#line2=re.sub(pattern2,'',line1)   #去除表情和其他字符
	#line2=line1
	#line3=re.sub(pattern3,'',line2)   #去除去掉残留的冒号及其它符号
	#line4=re.sub(pattern4,'',line3)

	#char_string = "ａ a ｂ b ｃ c ｄ d ｅ e ｆ f ｇ g ｈ h ｉ i ｊ j ｋ k ｌ l ｍ m ｎ n ｏ o ｐ p ｑ q ｒ r ｓ s ｔ t ｕ u ｖ v ｗ w ｘ x ｙ y ｚ z Ａ A Ｂ B Ｃ C Ｄ D Ｅ E Ｆ F Ｇ G Ｈ H Ｉ I Ｊ J Ｋ K Ｌ L Ｍ M Ｎ N Ｏ O Ｐ P Ｑ Q Ｒ R Ｓ S Ｔ T Ｕ U Ｖ V Ｗ W Ｘ X Ｙ Y Ｚ Z １ 1 ２ 2 ３ 3 ４ 4 ５ 5 ６ 6 ７ 7 ８ 8 ９ 9 ０ 0 ｀ ` ” " ’ ' “ ' ‘ " ＿ _ － - ～ ~ ＝ = ＋ + ＼ \ ｜ | ／ / （ ( ） ) ［ [ ］ ] 【 [ 】 ] ｛ { ｝ } ＜ < ＞ > ． . ， , ； ; ： : ！ ! ＾ ^ ％ % ＃ # ＠ @ ＄ $ ＆ & ？ ? ＊ * 。"

	#pattern11="[ಠಥз」∠இд◎]" #this is a string
	#line1=re.sub(pattern11,'',sentence)
	line1=sentence
	
	if replace_symbo_space_as_comma:
		pattern1="[｀`”\"’'“'‘\"＿_－-～~＝=＋+＼\\｜|／/（(）)［[］\]【[】\]｛\{｝\}＜<＞>．.，,；;：:！!＾^％%＃#＠@＄$＆&？?＊*。…-]"
		line1=re.sub(pattern1,',',line1) #this better??  全部符号替换为','
		#'\r\n '
		line1=line1.replace('\r',',')
		line1=line1.replace('\n',',')
		line1=line1.replace('\t',',')
	
	
	#pattern10='[,.:;"(.)"[,].]{2,}' #this wrong
	pattern10="[｀`”\"’'“'‘\"＿_－-～~＝=＋+＼\\｜|／/（(）)［[］\]【[】\]｛\{｝\}＜<＞>．.，,；;：:！!＾^％%＃#＠@＄$＆&？?＊*。…-]{2,}" #'[,.:[\];()!，。；、【】（）”“‘’]{2,}' #erase continuous char,e.g.:,,,=>,; NOTE:,.;[]^%=>, NOT ,.;[]^%=>,.;[]^%;

	#result = re.match(pattern10, line4)  #match() always return None; ???
	#result = re.search(pattern10, line4)  #search() is ok	
	#print(result.group())
	#line20=re.sub(pattern10,'',line4)
	
	#只保留汉字和标点字符
	pattern2 = re.compile(u'[^\s1234567890:：' + '\u4e00-\u9fa5]+')###important;
	line1=re.sub(pattern2,',',line1)
	a=0
	if replace_symbo_space_as_comma:
		line20=re.sub(pattern10,',',line1) #this better??  全部符号替换为','
		
	else:
		line20=re.sub(pattern10,cont2_repl,line1)#this seems bad
	
	if erase_space:
		new_sentence=''.join(line20.split()) #去除空白
	else:
		if replace_symbo_space_as_comma:
			line21=line20.replace(' ',',')
			line22=re.sub(pattern10,',',line21) #this better??  全部符号替换为','
			new_sentence=line22
		else:
			new_sentence=line20
	return new_sentence

#去除文本中的表情字符（只保留中英文和数字）
#https://m.hwz114.com/emojien.html
#https://www.webfx.com/tools/emoji-cheat-sheet/
#http://www.unicode.org/charts/PDF/U1F300.pdf
#Unicode码位的取值范围是0x0至0x10ffff——这是十六进制数，等于十进制数0到1114111
#新加入Unicode字符集的“颜文字”（Emoji）位于0x1f300~0x1f6ff区域。
def clear_character_emo(sentence):
	#pattern1= '\[.*?\]'     
	#pattern2 = re.compile('[^\u4e00-\u9fa5^a-z^A-Z^0-9^\uFF00-\uFFEF]')   #只取合法字符
	pattern2 = re.compile('[\u1F300-\u1F6FF]')
	#line1=re.sub(pattern1,'',sentence)
	#print(line1)
	line2=re.sub(pattern2,'',sentence)   
	new_sentence=''.join(line2.split()) #去除空白
	return new_sentence

def filter_emoji(desstr,restr=''):  
	#过滤表情   
	try:  
		res= re.compile(u'[\U00010000-\U0010ffff]')  
	except re.error:  
		res = re.compile(u'[\uD800-\uDBFF][\uDC00-\uDFFF]')  
	return res.sub(restr, desstr)

#https://blog.csdn.net/weixin_43420032/article/details/90314224?utm_medium=distribute.pc_relevant.none-task-blog-BlogCommendFromMachineLearnPai2-1.control&dist_request_id=&depth_1-utm_source=distribute.pc_relevant.none-task-blog-BlogCommendFromMachineLearnPai2-1.control
#NOTE: NOT erase emoji; but: [thum-up]=>'thumb-up'
def emoji2ascii(instr):
	ret=emoji.demojize(instr)
	return ret
#====================================================================
def encode_cvt_can_erase_emoji(instr):
	comment = str(bytes(instr, encoding='utf-8').decode('utf-8').encode('gbk', 'ignore').decode('gbk'))	
	return comment
#====================================================================
# 2、全角半角转化
# 中文文字永远是全角
# 只有英文字母、数字键、符号键才有全角半角的概念
# 一个字母或数字占一个汉字的位置叫全角，占半个汉字的位置叫半角。标点符号在中英文状态下、全半角的状态下是不同的。

# 有规律（不含空格）：
#     全角字符unicode编码从65281~65374 （十六进制 0xFF01 ~ 0xFF5E）；
#     半角字符unicode编码从33~126 （十六进制 0x21~ 0x7E）

# 特例：空格比较特殊，全角为 12288（0x3000），半角为 32（0x20）
#全角转半角
def full_to_half(sentence):      #输入为一个句子
	change_sentence=""
	for word in sentence:
		inside_code=ord(word)#以一个字符（长度为1的字符串）作为参数，返回对应的 ASCII 数值
		if inside_code==12288:    #全角空格直接转换
			inside_code=32
		elif inside_code>=65281 and inside_code<=65374:  #全角字符（除空格）根据关系转化
			inside_code-=65248
		change_sentence+=chr(inside_code)
	return change_sentence


#半角转全角
def half_to_full(sentence):      #输入为一个句子
	change_sentence=""
	for word in sentence:
		inside_code=ord(word)
		if inside_code==32:    #半角空格直接转换
			inside_code=12288
		elif inside_code>=32 and inside_code<=126:  #半角字符（除空格）根据关系转化
			inside_code+=65248
		change_sentence+=chr(inside_code)
	return change_sentence
#===================================================================
#繁体中文与简体中文替换
'''
!pip3 install opencc-python-reimplemented
from opencc import OpenCC
cc = OpenCC('s2t')  # 将简体中文转换为繁体中文
to_convert = '开放中文转换'
converted = cc.convert(to_convert)
print(converted)
#Output：'開放中文轉換'
cc.set_conversion('t2s')  #将繁体中文
print(cc.convert(converted))
#转换代码
# hk2s: 繁体中文（香港标准）转简体中文
# s2hk: 简体中文转繁体中文（香港标准）
# s2t: 简体中文转繁体中文
# s2tw: 简体中文转换成繁体中文（台湾标准）
# s2twp: 简体中文转繁体中文（带短语）
# t2hk: 繁体中文转繁体（香港标准）
# t2s: 繁体中文转简体
# t2tw: 繁体中文转繁体（台湾标准）
# tw2s: 繁体中文（台湾标准）转简体中文
# tw2sp:繁体中文（台湾标准）转简体中文（带短语）
#https://github.com/yichen0831/opencc-python/tree/master/opencc
'''
def traditional2s(instr):
	'''
	cc = OpenCC('s2t')  # 将简体中文转换为繁体中文
	to_convert = '开放中文转换'
	converted = cc.convert(to_convert)
	print(converted)
	#Output：'開放中文轉換'
	cc.set_conversion('t2s')  #将繁体中文
	print(cc.convert(converted))	
	'''
	cc = OpenCC('t2s')
	ret=cc.convert(instr)
	return ret
#====================================================================
if __name__ == "__main__":

	a=0
	#1st step
	#（1）删除全部半角的字母数字
	#（2）删除半角字符：删除“除标点之外的全部字符”，i.e.:只保留半角的：,.:";
	#（2）删除连续的特殊字符，如!!!,,,...@@@
	#2nd step
	#(1)半角=》全角
	#（2）删除连续的字符，如：！！; 。。;。。。。
	inputSrc='酷😀 😁 😂酷酷,,,哈哈哈..急;急急!!看看"""""。ABC,ab/c，了@呃呃[[[[环境]]]给,.;[]^%；急，急；急(哦哦哦)))日！日”哦"日哪‘里问【问線筆畫順序查詢'
	#aa=clear_character_emo(inputSrc)
	#aa0=emoji2ascii(inputSrc)
	aa1=encode_cvt_can_erase_emoji(inputSrc)
	aa=filter_emoji(inputSrc)
	bb=clear_character_half(aa)
	cc=clear_character_full(bb)
	
	#dd=full_to_half(cc)
	ee=traditional2s(cc)
	
	print('-'*50)
	print(inputSrc)
	print(aa1)
	print(aa)
	print(bb)
	print(cc)
	print(ee)
	a=0

	print('==== exit ====')
	os._exit(0)

